## mingw-w64-opencascade-7.9.2-2.src.tar.zst

=== src/TKDEVRML/CMakeLists.txt ===
project(TKDEVRML)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
