=== src/TKOffset/CMakeLists.txt ===
project(TKOffset)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
