=== src/TKTObjDRAW/CMakeLists.txt ===
project(TKTObjDRAW)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
